ViewModels/CarsListViewModel.cs
using shop.Data.Models;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;

namespace shop.ViewModels
{
    public class CarsListViewModel
    {
        public IEnumerable<Car> allCars { get; set; }
        public string currCategory { get; set; }
    }
}

ViewModels/HomeViewModel.cs
using shop.Data.Models;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;

namespace shop.ViewModels
{
    public class HomeViewModel
    {
        public IEnumerable<Car> favCars { get; set; }
    }
}

ViewModels/ShopCartViewModel.cs
using shop.Data.Models;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;

namespace shop.ViewModels
{
    public class ShopCartViewModel
    {
        public ShopCart shopCart { get; set; }

    }
}

Controllers/CarsController.cs
using Microsoft.AspNetCore.Mvc;
using shop.Data.Interfaces;
using shop.Data.Models;
using shop.ViewModels;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;

namespace shop.Controllers
{
    public class CarsController : Controller
    {
        private readonly iAllCars _allCars;
        private readonly iCarsCategory _allCategories;

        public CarsController(iAllCars i_all_cars, iCarsCategory i_cars_cat)
        {
            _allCars = i_all_cars;
            _allCategories = i_cars_cat;
        }

        [Route("Cars/List")]
        [Route("Cars/List/{category}")]
        public ViewResult List(string category)
        {
            string _category = category;
            IEnumerable<Car> cars = null;
            string currCategory = "";

            if (string.IsNullOrEmpty(category))
            {
                cars = _allCars.Cars.OrderBy(i => i.id);
            }
            else
            {
                if (string.Equals("electro", category, StringComparison.OrdinalIgnoreCase))
                {
                    cars = _allCars.Cars.Where(i => i.Category.categoryName.Equals("Электромобили")).OrderBy(i => i.id);
                    currCategory = "Электромобили";
                }
                else if (string.Equals("fuel", category, StringComparison.OrdinalIgnoreCase))
                {
                    cars = _allCars.Cars.Where(i => i.Category.categoryName.Equals("Классические автомобили")).OrderBy(i => i.id);
                    currCategory = "Классические автомобили";
                }         
            }

            var carObj = new CarsListViewModel
            {
                allCars = cars,
                currCategory = currCategory
            };

            ViewBag.Title = "Страница с автомобилями";
            return View(carObj);
        }
    }
}

Controllers/HomeController.cs
using Microsoft.AspNetCore.Mvc;
using shop.Data.Interfaces;
using shop.ViewModels;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;

namespace shop.Controllers
{
    public class HomeController:Controller
    {
        private readonly iAllCars _carRep;
        
        public HomeController(iAllCars carRep)
        {
            _carRep = carRep;
        }

        public ViewResult Index()
        {
            var homeCars = new HomeViewModel
            {
                favCars = _carRep.getFavCars
            };
            return View(homeCars);
        }
    }
}

Controllers/OrderController.cs
using Microsoft.AspNetCore.Mvc;
using shop.Data.Interfaces;
using shop.Data.Models;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;

namespace shop.Controllers
{
    public class OrderController : Controller
    {
        private readonly IAllOrders allOrders;
        private readonly ShopCart shopCart;

        public OrderController(IAllOrders allOrders, ShopCart shopCart)
        {
            this.allOrders = allOrders;
            this.shopCart = shopCart;
        }

        public IActionResult Checkout()
        {
            return View();
        }

        [HttpPost]
        public IActionResult Checkout(Order order)
        {
            shopCart.listShopItems = shopCart.GetShopItems();

            if (shopCart.listShopItems.Count == 0)
            {
                ModelState.AddModelError("", "У вас должны быть товары.");
            }

            if (ModelState.IsValid)
            {
                allOrders.createOrder(order);
                return RedirectToAction("Complete");
            }

            return View(order);
        }

        public IActionResult Complete()
        {
            ViewBag.Message = "Заказ успешно обработан!";
            return View();
        }
    }
}

Controllers/ShopCartController.cs
using Microsoft.AspNetCore.Mvc;
using shop.Data.Interfaces;
using shop.Data.Models;
using shop.ViewModels;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;

namespace shop.Controllers
{
    public class ShopCartController : Controller
    {
        private readonly iAllCars _carRep;
        private readonly ShopCart _shopCart;

        public ShopCartController(iAllCars carRep, ShopCart shopCart)
        {
            _carRep = carRep;
            _shopCart = shopCart;
        }

        public ViewResult Index()
        {
            var items = _shopCart.GetShopItems();
            _shopCart.listShopItems = items;

            var obj = new ShopCartViewModel
            {
                shopCart = _shopCart
            };

            return View(obj);
        }

        public RedirectToActionResult AddToCart(int id)
        {
            var item = _carRep.Cars.FirstOrDefault(i => i.id == id);
            if (item != null)
            {
                _shopCart.AddToCart(item);
            }
            return RedirectToAction("Index");
        }
    }
}

Views/Cars/LIst.cshtml
<h1>Все автомобили</h1>
<h3>@Model.currCategory</h3>
<div class="row mt-5 mb-2">
    @{
        foreach (Car car in Model.allCars)
        {
            @Html.Partial("AllCars", car)
        }
    }
</div>

Views/Home/Index.cshtml
@model HomeViewModel

<h1>Лучшие автомобили</h1>
<div class="row mt-5 mb-2">
    @{
        foreach (Car car in Model.favCars)
        {
            @Html.Partial("AllCars", car)
        }
    }
</div>

Views/Order/Checkout.cshtml
@model Order

<div class="row">
    <h3>Оформление заказа</h3>
    <form asp-action="Checkout" method="post" class="form-horizontal">
        <div class="form-group">
            <label asp-for="name"></label>
            <div class="col-md-5">
                <input asp-for="name" class="form-control" />
                <span asp-validation-for="name" class="text-danger"></span>
            </div>
        </div>
        <div class="form-group">
            <label asp-for="surname"></label>
            <div class="col-md-5">
                <input asp-for="surname" class="form-control" />
                <span asp-validation-for="surname" class="text-danger"></span>
            </div>
        </div>
        <div class="form-group">
            <label asp-for="address"></label>
            <div class="col-md-5">
                <input asp-for="address" class="form-control" />
                <span asp-validation-for="address" class="text-danger"></span>
            </div>
        </div>
        <div class="form-group">
            <label asp-for="phone"></label>
            <div class="col-md-5">
                <input asp-for="phone" class="form-control" />
                <span asp-validation-for="phone" class="text-danger"></span>
            </div>
        </div>
        <div class="form-group">
            <label asp-for="email"></label>
            <div class="col-md-5">
                <input asp-for="email" class="form-control" />
                <span asp-validation-for="email" class="text-danger"></span>
            </div>
        </div>
        <input class="btn btn-success" type="submit" value="Завершить заказ" />
    </form>
</div>

Views/Order/Complete.cshtml
<h3>
    @ViewBag.Message
</h3>

Views/Shared/AllCars.cshtml
@model shop.Data.Models.Car

<div class="col-lg-4">
    <img class="img-thumbnail" src="@Model.img" alt="@Model.name" />
    <h2>Модель: @Model.name</h2>
    <p>@Model.shortDesc</p>
    <p>Цена: @Model.price.ToString("c")</p>
    <p><a class="btn btn-warning" asp-controller="ShopCart" asp-action="AddToCart" asp-route-id="@Model.id">В корзину</a></p>
</div>

Views/Shared/_Layout.cshtml
<!DOCTYPE html>

<html>
<head>
    <meta name="viewport" content="width=device-width" />
    <title>@ViewBag.Title</title>
    <link href="~/css/bootstrap.min.css" rel="stylesheet" type="text/css" />
    <link href="~/css/style.css" rel="stylesheet" type="text/css" />
</head>
<body>
    <header>
        <nav class="navbar navbar-expand-md navbar-dark bg-dark">
            <a class="navbar-brand" href="#">Пример сайта</a>
            <button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#navbarCollapse" aria-controls="navbarCollapse" aria-expanded="false" aria-label="Toggle navigation">
                <span class="navbar-toggler-icon"></span>
            </button>
            <div class="collapse navbar-collapse" id="navbarCollapse">
                <ul class="navbar-nav mr-auto">
                    <li class="nav-item active">
                        <a class="nav-link" aps-controller="Home", asp-action="Index">Главная</a>
                    </li>
                    <li class="nav-item">
                        <a class="nav-link" href="/Cars/List">Машины</a>
                    </li>
                    <li class="nav-item">
                        <a class="nav-link" href="/Cars/List/electro">Электро</a>
                    </li>
                    <li class="nav-item">
                        <a class="nav-link" href="/Cars/List/fuel">Классика</a>
                    </li>
                    <li class="nav-item">
                        <a class="nav-link" href="/ShopCart/">Корзина</a>
                    </li>
                </ul>
                <form class="form-inline mt-2 mt-md-0">
                    <input class="form-control mr-sm-2" type="text" placeholder="Search" aria-label="Search">
                    <button class="btn btn-outline-success my-2 my-sm-0" type="submit">Search</button>
                </form>
            </div>
        </nav>
    </header>
    <div class="container mt-5">
        @RenderBody()
    </div>
    <footer class="container">
        <p class="float-right"><a href="#">Back to top</a></p>
        <p>© 2020 Все права защищены, Inc. · <a href="#">Соглашение</a></p>
    </footer>
    <script src="~/js/bootstrap.min.js"></script>
</body>
</html>

Views/ShopCart/Index.cshtml
@model ShopCartViewModel

<div class="container">
    @foreach (var el in Model.shopCart.listShopItems){
        <div class="alert alert-warning mt-3">
            <b>Автомобиль</b> @el.car.name <br />
            <b>Цена: </b>@el.car.price.ToString("c")
        </div>
    }
    <hr/>
    <a class="btn btn-danger" asp-controller="Order" asp-action="Checkout">Оплатить</a>
</div>